/* Exercise 2   *


*/

#include <stdio.h>
#include <string.h>
#include <mpi.h>

main(int argc, char** argv) 
{
    int my_rank;     /* Rank of process */
    int p;           /* Number of processes */
    int source;      /* Rank of sender   */
    int dest;        /* Rank of receiver */
    int tag=50;      /* Tag for messages */
    char message[100]; /* Storage for the message */
    MPI_Status status; /* Return status for receive */
    int  namelen;
    char processor_name[MPI_MAX_PROCESSOR_NAME];
   

    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
    MPI_Comm_size(MPI_COMM_WORLD, &p);

    if (my_rank==0)
      {
	printf("\n Please insert a message:\n");
	scanf("%s",message);
      }

    if (my_rank >0) {
      source = my_rank - 1;
      MPI_Recv(message,100,MPI_CHAR,source,
	       tag,MPI_COMM_WORLD, &status);
       };

    if (my_rank < p-1) {
      dest = my_rank + 1;
      MPI_Send(message,strlen(message)+1, 
	       MPI_CHAR, dest, tag, MPI_COMM_WORLD);
	}
    else
      {
	printf("\n \n The message is: %s\n \n",message); 
      };


    MPI_Finalize();
}
