/* Exercise 3 - Computing an approximate integral in serial
 *              (Example from Pacheco)
 *
 * Calculate definite integral using trapezoidal rule.
 * The function f(x) is hardwired.
 * Input: a, b, n.
 * Output: estimate of integral from a to b of f(x)
 *    using n trapezoids.
 *
 */

#include <stdio.h>
#include <math.h>

main() {
    float  integral;   /* Store result in integral   */
    float  a, b;       /* Left and right endpoints   */
    int    n;          /* Number of trapezoids       */
    float  h;          /* Trapezoid base width       */
    float  x;
    int    i;

    float f(float x);  /* Function we're integrating */

    printf("Enter a, b, and n\n");
    scanf("%f %f %d", &a, &b, &n);

    h = (b-a)/n;
    integral =  0.5 * ( f(a) + f(b) );
    x = a;
    for (i = 1; i < n; i++) {
        x = x + h;
        integral = integral + f(x);
    }
    integral = h * integral;

    printf("With n = %d trapezoids, our estimate\n",
        n);
    printf("of the integral from %f to %f = %f\n",
        a, b, integral);
} /* main */


float f(float x) {
    float return_val;
    /* Calculate f(x).  Store calculation in return_val. */

    return_val = 4*sqrt(1-x*x);
    printf("x = %f, f(x)= %f\n ",x,return_val);
    return return_val;
} /* f */
